VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} frm_Archiving 
   ClientHeight    =   4650
   ClientLeft      =   90
   ClientTop       =   330
   ClientWidth     =   9555
   OleObjectBlob   =   "frm_Archiving.frx":0000
   StartUpPosition =   1  'CenterOwner
End
Attribute VB_Name = "frm_Archiving"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
    Option Explicit
    
   'Konstante fr die Anzeige der Messagebox.
    Private Const mb_MSG_OPT As Integer = vbQuestion + vbYesNoCancel + vbDefaultButton2

Private Sub UserForm_Activate()

   'Prozess freigeben. Damit wird erreicht, dass die Prozedur, mit der die UserForm
   'aufgerufen wurde, weiter durchlaufen wird.
    DoEvents

End Sub

Private Sub cmdShow_Click()

   'Anzeige des aktuellen EMail-Objektes. Kann nur ausgefhrt werden, wenn der Archivierungs-
   'Prozess unterbrochen wurde, weil eine EMail-Adresse noch nicht zugeordnet wurde.
    
    With ga_Mails(UBound(ga_Mails))
        Application.Session.GetItemFromID(.sEntryID, .sStoreID).Display
    End With
    
End Sub

Private Sub cmdArchive_Click()

   'In dieser Prozedur wird das neue Verzeichnis und die unbekannte EMail-Adresse in die Datenbank
   'mit aufgenommen. Das EMail-Objekt selbst, wird hier noch nicht archiviert. Bevor das Verzeichnis
   'neu aufgenommen wird, muss zuerst geprft werden, ob evtl. bereits ein Verzeichnis mit gleichem
   'Namen existiert. In dem Fall wird automatisch die EMail-Adresse diesem Verzeichnis hinzugefgt.
    
    Dim i As Long
    
   'Prfen ob ein Verzeichnisname eingegeben wurde, sonst Prozedur abbrechen.
    If Trim(cboFolder.Text) = "" Then Exit Sub
    
    With ga_Mails(UBound(ga_Mails))
        
       'Indexwert in Variable schreiben.
        i = UBound(.saName)
       
       'Prozedur fr den DB-Eintrag des Folders starten.
        Call WriteDB_Folder(Trim(cboFolder.Text))
       
       'Prozedur fr den DB-Eintrag der EMail-Adresse starten.
        Call WriteDB_Address(.saName(i), .saAddress(i))
        
    End With
    
   'Archivierungs-Prozess fortsetzen.
    Call Continue_Archiving

End Sub

Private Sub cmdAcceptAll_Click()
    
   'In dieser Prozedur wird vom User eine Besttigung eingeholt, ob er wirklich alle nicht zugeordneten
   'EMail-Objekte mit dem automatisch erstellten Verzeichnis-Vorschlag archivieren mchte.
    
   'Definition der Konstante fr die Sicherheitsabfrage.
    Const sMSG_TXT As String = "Wollen Sie wirklich, dass alle nicht zugeordneten EMails automatisch " & _
                               "mit dem Verzeichnis-Vorschlag archiviert werden?" & vbCr & vbCr & _
                               "Diese Aktion kann nicht rckgngig gemacht werden!"

    
   'Besttigung des Users einholen.
    If MsgBox(sMSG_TXT, mb_MSG_OPT, "Vorschlge automatisch akzeptieren?") = vbYes Then
       'Flag fr die automatische Archivierung auf True setzen.
        gb_AcceptAll = True
       'Archivierungs-Prozess fortsetzen.
        Call Continue_Archiving
    End If

End Sub

Private Sub cmdIgnoreAll_Click()

   'In dieser Prozedur wird vom User eine Besttigung eingeholt, ob er wirklich alle nicht
   'zugeordneten EMail-Objekte automatisch ignorieren mchte.
    
   'Definition der Konstante fr die Sicherheitsabfrage.
    Const sMSG_TXT As String = "Wollen Sie wirklich, dass alle nicht zugeordneten EMail-" & _
                               "Adressen automatisch ignoriert und nicht archiviert werden?"

   'Besttigung des Users einholen.
    If MsgBox(sMSG_TXT, mb_MSG_OPT, "Neue Adressen automatisch ignorieren?") = vbYes Then
       'Flag fr die automatische Ignorierung auf True setzen.
        gb_IgnoreAll = True
       'Archivierungs-Prozess fortsetzen.
        Call cmdIgnore_Click
    End If

End Sub

Private Sub cmdIgnore_Click()
    
   'In dieser Prozedur wird das aktuelle, nicht zugeordnete EMail bersprungen. Das bedeutet,
   'dass dieses EMail-Objekt nicht archiviert wird.
    
   'Letztes (aktuelles) EMail aus dem benutzerdefinierten Array entfernen.
    ReDim Preserve ga_Mails(UBound(ga_Mails) - 1) As Mail_TYPE
    
   'Array der bereits ermittelten Verzeichnisse zurcksetzen.
    ReDim gsa_Folders(0) As String
    
   'String fr die Prfung der doppelten Archivierung zurcksetzen.
    gs_Multiple = Empty
    
   'Archivierungs-Prozess fortsetzen.
    Call Continue_Archiving
    
End Sub

Private Sub cboFolder_Change()
    
   'Wenn sich der Text in der Combobox ndert, wird berprft, ob dieser auch in der Listbox vorkommt.
   'Ist dies der Fall, wird der bereinstimmende Eintrag in der Listbox markiert, sodass der User merkt,
   'dass er eine Bezeichnung eines bereits bestehenden Verzeichnisses ausgewhlt hat.
    
    Dim i As Long

    With listSuggestion
            .ListIndex = -1
        For i = 0 To .ListCount - 1
            If .List(i, 0) = cboFolder.Text Then
                .ListIndex = i
                Exit For
            End If
        Next i
    End With

End Sub

Private Sub listSuggestion_AfterUpdate()
    
   'Wird aus der Listbox ein Verzeichnisnamen ausgewhlt, wird der Text in die Combobox bernommen.
   'Denn nur der Name der letzt endlich in der Combobox steht, wird bei der Archivierung verwendet.
    
    With listSuggestion
        If .ListIndex <> -1 Then
            cboFolder.Text = .List(.ListIndex, 0)
        End If
    End With
    
End Sub

Private Sub UserForm_Terminate()

   'Wenn die UserForm entladen wird, werden alle Globalen Variablen zurckgesetzt. Damit
   'wird erreicht, dass der reservierte Speicher fr diese Variablen wieder freigegeben wird.
   
   'Objekt-Variablen zurcksetzen.
    Set gdb_Mails = Nothing
    Set gdb_Folders = Nothing

   'Benutzerdefinierte Arrays zurcksetzen.
    ReDim ga_Mails(0) As Mail_TYPE
    ReDim ga_Archives(0) As Archive_TYPE

End Sub

Private Sub cmdCancel_Click()
    
   'Falls der User whrend der Ausfhrung des Prozesses auf "Abbrechen" klickt, wird 'gl_CANCEL' auf
   'True gesetzt. Falls ein anderer Prozess noch ausgefhrt wird, muss dieser zuerst beendet werden.
   'Daher wird die Unload Anweisung erst dann ausgefhrt, wenn alle Prozeduren beendet sind.
   
   'Prfen ob der Abbruch-Prozess bereits im Gange ist.
    If gl_Cancel <> Abort.Interrupted Then
        Call Cancel_Process(Me)
    End If
   
End Sub

Private Sub UserForm_QueryClose(Cancel As Integer, CloseMode As Integer)
    
   'Falls der User versucht die UserForm auf eine alternative Weise zu schliessen, zBsp. mit ALT + F4
   'oder mit dem Schliessen-Button, wird dies abgefangen. Damit wird erreicht, dass der User die UserForm
   'nur schliessen kann, wenn er dies mit der Messagebox (siehe Prozedur Cancel_Process) besttigt.
   
   'Prfen, ob der User versucht die UserForm zu schliessen.
    If CloseMode = vbFormControlMenu Then
       'Prfen ob der Abbruch-Prozess bereits im Gange ist.
        If gl_Cancel <> Abort.Interrupted Then
           'Prozedur fr die Besttigung des Users aufrufen.
            Call Cancel_Process(Me, Cancel)
        Else
           'Abbruch-Versuch zurcksetzen.
            Cancel = True
        End If
    End If
    
End Sub
