VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} frm_CreateFolder 
   Caption         =   " Neues Archiv-Verzeichnis erstellen"
   ClientHeight    =   3405
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4980
   OleObjectBlob   =   "frm_CreateFolder.frx":0000
   StartUpPosition =   1  'CenterOwner
End
Attribute VB_Name = "frm_CreateFolder"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

   'Datum des EMails in Variable auf Modulebene schreiben.
    Private mdt_Mail As Date

Private Sub UserForm_Initialize()

   'Das Initialize Ereignis wird ausgefhrt, wenn die UserForm geladen wird. In dieser Prozedur wird
   'als Information fr den User, die bereits bestehenden Archiv-Verzeichnisse in eine Listbox ge-
   'schrieben. Zudem wird ein Standart Name inkl. einer Standart Zeitspanne fr das neue Archiv-
   'Verzeichnis vorgeschlagen.
    
    Dim i As Long
    
   'Da whrend der Erstellung des Archiv-Verzeichnisses kein Prozess im Gange ist, muss das Flag fr
   'den Abbruch auf True gesetzt werden, damit der User auch in dieser Form die Mglichkeit hat, den
   'Archivierungs-Prozess sofort zu beenden.
    gl_Cancel = Abort.UserEditing
    
   'Schleife fr alle bestehenden Archiv-Verzeichnisse initialisieren.
    For i = 1 To UBound(ga_Archives)
       'Archiv-Verzeichnisse in Listbox anzeigen.
        With listArchives
            .AddItem
            .List(.ListCount - 1, 0) = ga_Archives(i).sFolderName
            .List(.ListCount - 1, 1) = Format(ga_Archives(i).dtFrom, "dd.mm.yyyy")
            .List(.ListCount - 1, 2) = "bis"
            .List(.ListCount - 1, 3) = Format(ga_Archives(i).dtTo, "dd.mm.yyyy")
        End With
    Next i
    
   'Laufzeitfehler bei der Ermittlung der Standart-Texte unterdrcken.
    On Error Resume Next
    
   'Datum des EMails in Variable schreiben.
    mdt_Mail = CDate(frm_Archiving.txtSentOn.Tag)
   
   'Standart Zeitspanne fr Archivierung ermitteln und in Textboxen schreiben.
    txtFrom.Text = Format(DateSerial(Year(mdt_Mail), 1, 1), "dd.mm.yyyy")
    txtTo.Text = Format(DateSerial(Year(mdt_Mail), 12, 31), "dd.mm.yyyy")
    
   'Standart Text fr Archiv-Verzeichnis ermitteln und Text markieren.
    txtName.Text = "Archiv_" & Year(mdt_Mail)
    txtName.SetFocus
    txtName.SelStart = 0
    txtName.SelLength = Len(txtName.Text)
    
End Sub

Private Sub cmdCreate_Click()

   'In dieser Prozedur wird das Archiv-Verzeichnis erstellt. Bevor es erstellt werden kann, mssen zu-
   'erst diverse Plausibilitts-Checks vorgenommen werden.

    Dim i           As Long
    Dim bolSign     As Boolean
    Dim strPath     As String
    Dim strErrMsg   As String
    Dim objFolder   As MAPIFolder
    Dim objCtrl     As MSForms.TextBox
    
   'Fehlerroutine initialisieren.
    On Error GoTo Err_CreateArchiveFolder
    
   'Pfad des Archiv-Verzeichnisses in Variable schreiben.
    strPath = gs_PATH & Replace(RTrim(txtName.Text), ".pst", "") & ".pst"
    
   'Prfen ob im Archiv-Name Sonderzeichen vorkommen, falls ja Flag auf True setzen.
    Do Until i = Len(txtName.Text)
        i = i + 1
        If InStr(1, "\/:*?<>|" & Chr(34), Mid(txtName.Text, i, 1)) <> 0 Then
            bolSign = True
            Exit Do
        End If
    Loop
    
   'In Select Case Block werden zuerst alle mglichen Fehlerquellen bei der Erstellung des Archivs
   'berprft. Erst wenn keine Fehlerprfung positiv ist, wird das Archiv-Verzeichnis erstellt. In der
   'Fehlerbehandlung wird jeweils der Objekt-Variablen 'objCtrl' das entsprechende Textfeld zugewiesen,
   'dass den Fehler verursacht. Dannn erhlt das Textfeld den Fokus und der Inhalt wird markiert, damit
   'der User sofort nderungen vornehmen kann.
   
    Select Case False
    
       'Fehlermeldung wenn kein Name eingegeben oder Sonderzeichen benutzt wurden!
        Case Trim(txtName.Text) <> "" And bolSign = False
            
            Set objCtrl = txtName
            strErrMsg = "Der eingegebene Archiv-Name (Verzeichnisname) ist nicht gltig." & vbCr & _
                        "Die Sonderzeichen \/:*?<>|"" drfen nicht verwendet werden!"

       'Fehlermeldung wenn Name des Archiv-Verzeichnisses bereits besteht!
        Case Dir(strPath) = ""
        
            Set objCtrl = txtName
            strErrMsg = "Es existiert bereits ein Archiv-Verzeichnis mit diesem Namen!"

       'Fehlermeldung wenn kein korrektes Datumsformat eingegeben wurde!
        Case IsDate(txtFrom.Text)
            
            Set objCtrl = txtFrom
            strErrMsg = "Das eingegebene Datum konnte nicht erkannt werden.!" & vbCr & _
                        "Das Datum muss im Format 'TT.MM.JJJJ' eingegeben werden."
            
       'Fehlermeldung wenn kein korrektes Datumsformat eingegeben wurde!
        Case IsDate(txtTo.Text)
            
            Set objCtrl = txtTo
            strErrMsg = "Das eingegebene Datum konnte nicht erkannt werden.!" & vbCr & _
                        "Das Datum muss im Format 'TT.MM.JJJJ' eingegeben werden."
            
       'Fehlermeldung wenn Datum des EMails nicht innerhalb der Zeitspanne liegt.
        Case CDate(txtFrom.Text) <= mdt_Mail
        
            Set objCtrl = txtFrom
            strErrMsg = "Das Datum des E-Mails muss innerhalb der Zeitspanne liegen!" & vbCr & _
                        "Das Von-Datum darf nicht grsser sein als der " & Format(mdt_Mail, "dd.mm.yyyy")
            
       'Fehlermeldung wenn Datum des EMails nicht innerhalb der Zeitspanne liegt.
        Case CDate(txtTo.Text) >= mdt_Mail
        
            Set objCtrl = txtTo
            strErrMsg = "Das Datum des E-Mails muss innerhalb der Zeitspanne liegen!" & vbCr & _
                        "Das Bis-Datum darf nicht kleiner sein als der " & Format(mdt_Mail, "dd.mm.yyyy")
        
       'Keine Fehlermeldung, Archiv-Verzeichnis kann erstellt werden!
        Case Else
                
           'Standart-Fehlermeldung bei einem Laufzeitfehler definieren.
            strErrMsg = "Ein ubekannter Fehler ist aufgetreten!"
            
           'Archiv-Verzeichnis erstellen und in Objekt-Variable schreiben.
            Application.Session.AddStoreEx strPath, olStoreDefault
            Set objFolder = Application.Session.Folders.GetLast
             
            With objFolder
                
                'Name, Ansicht und Description des Archiv-Verzeichnisses ndern.
                .Name = RTrim(txtName.Text)
                .ShowItemCount = olShowTotalItemCount
                .Description = gs_DESCRIPTION & vbCrLf & _
                               Format(CDate(txtFrom.Text), "dd.mm.yyyy") & vbCrLf & _
                               Format(CDate(txtTo.Text), "dd.mm.yyyy")
                
                'Neues Archiv-Verzeichnis in Archiv-Array aufnehmen.
                Call Add_ArchiveFolder(objFolder)
                
                'Vordefiniertes View Objekt auf neues Archiv-Verzeichnis anwenden.
                .Views(gs_VIEW).Apply
                .Views(gs_VIEW).LockUserChanges = False
                
            End With
                
           'Das Flag fr den Abbruch wieder auf False zurcksetzen.
            gl_Cancel = Abort.InProgress
            
           'UserForm schliessen und Prozedur beenden.
            Unload Me
            Exit Sub
            
        End Select
    
   'Textfeld das Fehler ausgelst hat aktivieren und Inhalt markieren.
    If Not objCtrl Is Nothing Then
        objCtrl.SetFocus
        objCtrl.SelStart = 0
        objCtrl.SelLength = Len(objCtrl.Text)
    End If
    
Err_CreateArchiveFolder:

   'Eingabe- oder Laufzeitfehler anzeigen.
    Call Error_Msg(Err, strErrMsg)
    
End Sub

Private Sub txtFrom_KeyPress(ByVal KeyAscii As MSForms.ReturnInteger)
   
   'Verhindern, dass der User alphanumerische Zeichen eingeben kann.
    If InStr(1, "0123456789.", Chr(KeyAscii), vbBinaryCompare) = 0 Then
        KeyAscii = 0
    End If
    
End Sub

Private Sub txtTo_KeyPress(ByVal KeyAscii As MSForms.ReturnInteger)
   
   'Verhindern, dass der User alphanumerische Zeichen eingeben kann.
    If InStr(1, "0123456789.", Chr(KeyAscii), vbBinaryCompare) = 0 Then
        KeyAscii = 0
    End If
    
End Sub

Private Sub Get_Date(ByRef rCtrl As MSForms.Control)
   
   'Prfen ob das Textfeld ein Datum enthlt.
    If IsDate(rCtrl.Text) Then
       'Datum entsprechend formatieren.
        rCtrl.Text = Format(rCtrl.Text, "dd.mm.yyyy")
    Else
       'Falls kein Datum eingegeben wurde, Textbox zurcksetzen.
        rCtrl.Text = ""
    End If
    
End Sub

Private Sub txtFrom_Exit(ByVal Cancel As MSForms.ReturnBoolean)
   
   'Eingabe prfen und formatieren.
    Call Get_Date(txtFrom)
    
   'Falls keine Eingabe im Feld From besteht, automatisch 1 Jahr vorschlagen.
    If txtTo.Text = "" And txtFrom.Text <> "" Then
       'Vorschlag fr Zeitspanne ermitteln (1 Jahr)
        txtTo.Text = DateSerial(Year(txtFrom.Text), Month(txtFrom.Text) + 12, Day(txtFrom.Text) - 1)
    End If
    
End Sub

Private Sub frameName_Exit(ByVal Cancel As MSForms.ReturnBoolean)
   
   'Eingabe prfen und formatieren.
    Call Get_Date(txtTo)
    
End Sub

Private Sub txtTo_Exit(ByVal Cancel As MSForms.ReturnBoolean)
   
   'Eingabe prfen und formatieren.
    Call Get_Date(txtTo)
    
End Sub

Private Sub cmdCancel_Click()
    
   'Falls der User whrend der Ausfhrung des Prozesses auf "Abbrechen" klickt, wird 'gl_CANCEL' auf
   'True gesetzt. Falls ein anderer Prozess noch ausgefhrt wird, muss dieser zuerst beendet werden.
   'Daher wird die Unload Anweisung erst dann ausgefhrt, wenn alle Prozeduren beendet sind.
   
    If gl_Cancel <> Abort.Interrupted Then
        Call Cancel_Process(Me)
    End If
   
End Sub

Private Sub UserForm_QueryClose(Cancel As Integer, CloseMode As Integer)
    
   'Falls der User versucht die UserForm auf eine alternative Weise zu schliessen, zBsp. mit ALT + F4
   'oder mit dem Schliessen-Button, wird dies abgefangen. Damit wird erreicht, dass der User die UserForm
   'nur schliessen kann, wenn er dies mit der Messagebox (siehe Prozedur Cancel_Process) besttigt.
   
   'Prfen, ob der User versucht die UserForm zu schliessen.
    If CloseMode = vbFormControlMenu Then
       'Prfen ob der Abbruch-Prozess bereits im Gange ist.
        If gl_Cancel <> Abort.Interrupted Then
           'Prozedur fr die Besttigung des Users aufrufen.
            Call Cancel_Process(Me, Cancel)
        Else
           'Abbruch-Versuch zurcksetzen.
            Cancel = True
        End If
    End If
    
End Sub
