Attribute VB_Name = "mod_Archiving"
    Option Explicit
    
   'Definition der Konstaten fr die benutzerdefinierten Feld-Namen.
    Private Const ms_FIELD_SENT  As String = "Sent by"          'Feld fr den Sender
    Private Const ms_FIELD_DATE  As String = "Sent & Received"  'Feld fr Sende- oder Empfangsdatum
    
Sub Initialize_Archiving(Optional ByVal vPrivate As Byte)

   'In dieser Prozedur werden die Globalen Variablen entsprechend definiert, damit die Archivierung der
   'EMails gestartet werden kann. Zudem werden die einzelnen Tabellen der Access Datenbank geffnet und
   'ebenfalls in eine Globale Variable geschrieben. Der Parameter vPrivate wird bloss dazu verwendet,
   'damit die Prozedur nicht ber das Men Extras => Makro => Makros gestartet werden kann.

    Dim strConnect As String
    
   'Form fr das Auslesen der EMail-Objekte schliessen.
    Unload frm_ReadObjects
    
   'Globale Variablen zurcksetzen.
    gs_Multiple = Empty
    gb_IgnoreAll = False
    gb_AcceptAll = False
    ReDim gsa_Folders(0) As String
    
   'Connection-String fr die Datenbank-Verbindung erstellen.
    strConnect = "Provider=Microsoft.Jet.OLEDB.4.0;" & _
                 "Data Source=" & gs_PATH & gs_DBASE & ";" & _
                 "User Id=admin;" & _
                 "Password=;"
    
   'Tabellen der Datenbank in globale Objekt-Variablen schreiben.
    gdb_Mails.Open "Addresses", strConnect, adOpenKeyset, adLockOptimistic, adCmdTable
    gdb_Folders.Open "Folders", strConnect, adOpenKeyset, adLockOptimistic, adCmdTable
    
   'UserFrom fr die Archivierung ungebunden anzeigen.
    frm_Archiving.Show False
    
   'Archivierung starten.
    Call Continue_Archiving

End Sub

Public Sub Continue_Archiving(Optional ByVal vPrivat As Byte)

   'In dieser Prozedur werden allgemeine nderungen auf der UserForm vorgenommen, wenn von der Bearbei-
   'tung in den Archivierungsprozess gewechselt wird. Das heisst es werden zBsp. die Steuerelemente de-
   'aktiviert, der Text in der Titelleiste gendert usw. Zudem berprft diese Prozedur, nachdem die
   'Archivierung beendet oder unterbrochen wird, ob der User versucht hat, den Archivierungs-Prozess zu
   'unterbrechen. Der Parameter vPrivat wird bloss dazu verwendet, damit die Prozedur nicht ber das
   'Men => Extras => Makro => Makros gestartet werden kann.
    
   'Titelleiste anpassen und Vorschlge lschen.
    With frm_Archiving
        .Caption = " EMail Objekte werden archiviert - Bitte warten..."
        .cboFolder.Clear
        .cboFolder.Text = ""
        .listSuggestion.Clear
    End With

   'Steuerelemente auf der UserForm deaktivieren.
    Call Enable_Controls(False)

   'Flag fr den Prozess-Unterbruch zurcksetzen.
    gl_Cancel = Abort.InProgress

   'Archivierungs-Prozess fortsetzen.
    Call Archive_MailItems
    
   'Prfen ob der User, den Prozess unterbrechen mchte.
    If gl_Cancel = Abort.Interrupted Then
       
       'Falls Prozess-Abbruch bereits besttigt wurde, UserForm entladen.
        Unload frm_Archiving
        
    Else
    
       'Flag muss gendert werden, weil Teilprozess beendet wurde.
        gl_Cancel = Abort.UserEditing
       
       'Titelleiste der UserForm anpassen.
        frm_Archiving.Caption = " Unbekannte EMail-Adresse gefunden - Bitte zuordnen!"
    
       'Steuerelemente auf der UserForm aktivieren.
        Call Enable_Controls(True)
        
    End If

End Sub

Private Sub Archive_MailItems()

   'In dieser Prozedur wird berprft, ob die aktuell bearbeitete EMail-Adresse bereits einem Verzeich-
   'nis zugeordnet wurde oder nicht. Im Fall, dass Sie bereits zugeordnet wurde, wird das EMail-Objekt
   'in das entsprechende Verzeichnis archiviert.
    
    Dim i           As Long
    Dim j           As Long
    Dim strFolder   As String
    Dim objItem     As Object
    Dim pRec        As Mail_TYPE
    
   'Schleife fr alle EMail-Objekte initialisieren.
    For i = UBound(ga_Mails) To 1 Step -1
    
       'Aktueller Datensatz in Variable schreiben.
        pRec = ga_Mails(i)
    
       'EMail Objekt in Variable schreiben.
        Set objItem = Application.Session.GetItemFromID(pRec.sEntryID, pRec.sStoreID)
              
       'Aktuelle Daten des EMail-Objektes in UserForm anzeigen.
        Call Show_DataMailItem(objItem, pRec)
       
       'Schleife fr alle Empfnger/Sender initialisieren.
        For j = UBound(pRec.saName) To 0 Step -1
            
           'Prfen ob der User den Prozess abbrechen mchte.
            If gl_Cancel = Abort.Interrupted Then Exit Sub
            
           'Aktuelle Daten der Empfnger/Sender in der UserForm anzeigen.
            Call Show_DataRecipient(pRec.saName(j), j + 1, UBound(gsa_Folders))
        
           'Prfen ob bereits ein Verzeichnisname fr die Adresse existiert.
            strFolder = Get_FolderName(pRec.saName(j), pRec.saAddress(j))
            
           'Prfen ob Verzeichnisname gefunden wurde.
            If strFolder = "" Then
                
                If gb_IgnoreAll Then
                   
                   'Falls "Alle Ignorieren" angeklickt wurde, werden alle nicht zugeordneten EMails
                   'nicht archiviert und automatisch ignoriert.
                   
                   'Aktuelles nicht zugeordnetes EMail lschen.
                    ReDim Preserve ga_Mails(UBound(ga_Mails) - 1) As Mail_TYPE
                   
                   'Variablen zurcksetzen.
                    ReDim gsa_Folders(0) As String
                    gs_Multiple = Empty
                    Exit For
                    
                Else
              
                   'Falls kein Verzeichnis mit diesem Namen existiert. Prozedur fr die Ermittlung der
                   'Vorschlge fr den Verzeichnisnamen starten.
                    Call Get_Suggestion(pRec.saName(j), pRec.saAddress(j))
                     
                   'Prozedur vorzeitig beenden, damit User den Vorschlag besttigen oder ndern kann.
                    Exit Sub
                    
                End If
                
            Else
                
               'Prfen ob das aktuelle EMail-Objekt bereits diesem Verzeichnis zugeordnet wurde.
                If InStr(1, gs_Multiple, vbTab & strFolder, vbBinaryCompare) = 0 Then
                     
                   'Check-Variable mit Verzeichnisnamen ergnzen.
                    gs_Multiple = gs_Multiple & vbTab & strFolder
            
                   'Verzeichnisname hinzufgen.
                    ReDim Preserve gsa_Folders(UBound(gsa_Folders) + 1) As String
                    gsa_Folders(UBound(gsa_Folders)) = strFolder
                    
                End If
                 
               'Aktueller abgearbeiteter Empfngername aus Array entfernen.
                If j > 0 Then ReDim Preserve ga_Mails(i).saName(j - 1) As String
                
            End If
            
        Next j

       'Prfen, ob dem EMail-Objekt mindestens 1 Verzeichnisname zugeordnet wurde.
        If UBound(gsa_Folders) > 0 Then
        
           'Falls ja, wird die Sub fr die Archivierung gestartet.
            Call Move_MailItem(objItem, pRec.bSentMySelf)
            
        End If
        
    Next i
        
   'Menbutton wieder aktivieren.
    g_CmdButton.Enabled = True
        
   'Falls alle EMail-Objekte archiviert wurden, UserForm entladen.
    Unload frm_Archiving

End Sub

Private Sub Move_MailItem(ByRef rItem As Object, ByVal vbSent As Boolean)

   'In dieser Prozedur wird das EMail-Objekt in jedes Verzeichnis kopiert, dem es zugeordnet wurde.

    Dim i           As Long
    Dim objCopy     As Object
    Dim objArchiv   As MAPIFolder
    
   'Archiv-Verzeichnis suchen und in Variable schreiben.
    Set objArchiv = Get_ArchivFolder(rItem.SentOn)
    
   'Prfen ob User den Archivierungs-Prozess unterbrochen hat.
    If gl_Cancel = Abort.Interrupted Then Exit Sub
    
   'Benutzerdefinierte Felder im EMail-Objekt hinzufgen.
    Call Add_UserProperties(rItem, vbSent)
   
   'Schleife fr Archiv-Verzeichnisse initialisieren. Die 1. Position wird weggelassen, da bei allen
   'anderen Positionen das EMail-Objekt kopiert werden muss. Fr das letzte Verzeichnis wird das
   'EMail nicht kopiert sondern verschoben. Whrend des Kopiervorganges kann der Prozess nicht unter-
   'brochen werden.
   
    For i = UBound(gsa_Folders) To 2 Step -1
        
       'Fortschritt der Archivierung anzeigen.
        Call Show_DataRecipient(gsa_Folders(i), 0, i - 1)
        
       'EMail-Objekt kopieren.
        Set objCopy = rItem.Copy
        
        With objCopy
            
           'Falls EMail empfangen wurde, Name des Senders aktualisieren.
            If Not vbSent Then
                .UserProperties(ms_FIELD_SENT).Value = gsa_Folders(i)
                .Save
            End If
            
           'Kopie des EMail-Objektes in Archive-Verzeichnis verschieben.
            .Move Get_SubFolder(objArchiv, gsa_Folders(i))
            
        End With
        
    Next i
    
   'Original EMail-Objekt in Archiv-Verzeichnis verschieben.
    Call Show_DataRecipient(gsa_Folders(1), 0, 0)
    rItem.Move Get_SubFolder(objArchiv, gsa_Folders(1))
   
   'String fr die Prfung ob das EMail in einem Verzeichnis doppelt vorhanden ist, zurcksetzen.
    gs_Multiple = Empty
    
   'Array fr die Speicherung der einzelnen Verzeichnisnamen zurcksetzen.
    ReDim gsa_Folders(0) As String
    
   'Gesamte Daten des EMails in benutzerdefiniertem Array entfernen.
    ReDim Preserve ga_Mails(UBound(ga_Mails) - 1) As Mail_TYPE

End Sub

Private Sub Add_UserProperties(ByRef rItem As Object, ByVal vbSent As Boolean)

   'In dieser Prozedur wird dem aktuellen EMail-Objekt 2 neue benutzerdefinierte Felder hinzugefgt.
   'Zuerst wird das Feld "Sent by" hinzugefgt. Es beinhaltet entweder den Namen des Senders, welcher
   'mit dem Verzeichnisnamen bereinstimmt oder den Namen des User des aktuellen Accounts. Danach wird
   'das Feld 'Sent & Received' hinzugefgt, dass entweder das Sende- oder Empfangsdatum beinhaltet.
   
   'Das Feld 'Sent by' wird spter dafr benutzt um innerhalb der einzelnen Archiv-Verzeichnisse die
   'EMails nach Sender zu gruppieren. Eine Gruppe fr die erhaltenen EMails und eine fr die gesendeten.

   'Feld 'Sent by' hinzufgen und den Sender des EMails hinzufgen.
    With rItem.UserProperties.Add(ms_FIELD_SENT, olText, True)
        If vbSent Then
           'Aktueller User als Sender des EMails hinzufgen (Leerzeichen dient dazu, dass im Archiv
           'Verzeichnis die gesendeten E-Mails an 1. stelle erscheinen.
            .Value = " " & Application.Session.CurrentUser
        Else
           'Name des 1. Verzeichnisses als Sender des EMails hinzufgen.
            .Value = gsa_Folders(1)
        End If
    End With
    
   'Feld 'Sent & Received hinzufgen und je nachdem Sende- oder Empfangsdatum hinzufgen.
    With rItem.UserProperties.Add(ms_FIELD_DATE, olDateTime, True)
        If vbSent Then
           'Sendedatum hinzufgen
            .Value = rItem.SentOn
        Else
           'Empfangsdatum hinzufgen
            .Value = rItem.ReceivedTime
        End If
    End With
    
   'nderungen im EMail-Objekt speichern.
    rItem.Save
        
End Sub

Private Sub Show_DataMailItem(ByRef rItem As Object, ByRef rRec As Mail_TYPE)
    
   'In dieser Prozedur werden die allgemeinen Daten des aktuellen EMail-Objektes auf die UserForm ber-
   'tragen. Mit DoEvents wird sichergestellt, dass der User den Fortschritt der EMail-Archivierung mit-
   'verfolgen kann.
    
    With frm_Archiving
        .txtSubject.Text = rItem.Subject
        .txtCountAtt.Text = rItem.Attachments.Count
        .txtSentOn.Text = Format(rItem.SentOn, "dddd, dd.mm.yyyy - hh:mm:ss")
        .txtSentOn.Tag = Format(rItem.SentOn, "dd.mm.yyyy")
        .txtSize.Text = Format(rItem.Size, "#,##0")
        .txtObjOutstanding.Text = Format(UBound(ga_Mails), "#,##0")
        .txtRecipOutstanding.Text = Format(UBound(rRec.saName) + 1, "#,##0")
        .txtArchivOutstanding.Text = Format(UBound(gsa_Folders), "#,##0")
    End With
    
   'Prozess freigeben.
    DoEvents
    
End Sub

Private Sub Show_DataRecipient(ByVal vsName As String, ByVal vlR As Long, ByVal vlA As Long)
    
   'In dieser Prozedur werden die allgemeinen Daten des aktuellen Empfngers/Senders auf die UserForm
   'bertragen. Mit DoEvents wird sichergestellt, dass der User den Fortschritt der EMail-Archivierung
   'mitverfolgen kann.
    
    With frm_Archiving
        .txtSender.Text = vsName
        .txtRecipOutstanding.Text = Format(vlR, "#,##0")
        .txtArchivOutstanding = Format(vlA, "#,##0")
    End With
   
   'Prozess freigeben.
    DoEvents
    
End Sub

Private Function Get_FolderName(ByVal vsName As String, ByVal vsAddress As String)

   'In dieser Prozedur wird geprft, ob die aktuelle EMail-Adresse bereits in der Datenbank einem Ver-
   'zeichnis zugeordnet wurde. Falls der Button "Alle Akzeptieren" angeklickt wurde, wird autom. ein
   'Verzeichnisname erstellt (d.h. in der Datenbank hinzugefgt).
    
    Dim vntSuggestion As Variant
    
   'Nach EMail-Adresse in der Datenbank suchen.
    gdb_Mails.Find "Address = '" & vsAddress & "'", , , 1

   'Prfen ob ein Eintrag in der Datenbank gefunden wurde, falls nicht wurde der EMail-Adresse noch
   'kein Verzeichnisname zugeordnet. In dem Fall wird die Prozedur beendet.
   
    If Not gdb_Mails.EOF Then

       'Falls die EMail-Adresse in der DB vorhanden ist, besteht auch ein entsprechendes Verzeichnis
       'dazu. Hier wird nun in der Tabelle der Verzeichnisse nach dem entsprechenden Eintrag gesucht.
       'Danach werden die Felder "LastUsed" in beiden Tabellen mit dem aktuellen Datum angepasst.
        Get_FolderName = WriteDB_Folder(gdb_Mails!folder)
        Call WriteDB_LastUsed
    
    ElseIf gb_AcceptAll Then
    
       'Falls die EMail-Adresse noch nicht zugeordnet wurde, der User jedoch die automatisch Archivie-
       'rung (Button "Alle Akzeptieren") angeklickt hat, wird zuerst ein Verzeichnisname automatisch
       'ermittelt, und danach die EMail-Adresse sowie den Verzeichnisnamen der Datenbank hinzugefgt.
        
       'Prozedur fr die Ermittlung des Verzeichnisnamens aufrufen.
        vntSuggestion = Get_Suggestion(vsName, vsAddress)
        
       'Name in Datenbank hinzufgen.
        Get_FolderName = WriteDB_Folder(vntSuggestion(0))
        Call WriteDB_Address(vsName, vsAddress)
        Call WriteDB_LastUsed
    
    End If

End Function

Public Function WriteDB_Folder(ByVal vsFolderName As String) As String

   'In dieser Funktion wird geprft, ob der Verzeichnisname in der DB bereits vorhanden ist. Falls
   'nicht, wird ein neuer Datensatz mit dem entsprechenden Verzeichnisnamen erstellt. Die Funktion gibt
   'in jedem Fall den Namen des neu erstellten oder bereits vorhandenen Verzeichnisses zurck.

   'Nach dem Verzeichnisnamen suchen.
    gdb_Folders.Find "Folder = '" & vsFolderName & "'", , , 1
    
   'Prfen ob ein Eintrag gefunden wurde.
    If gdb_Folders.EOF Then
        gdb_Folders.AddNew                  'Neuer Datensatz erstellen.
        gdb_Folders!folder = vsFolderName   'Verzeichnisname hinzufgen.
        gdb_Folders!EntryDate = Now         'Erstellungsdatum hinzufgen.
        gdb_Folders.Update                  'Datensatz speichern.
    End If

   'Verzeichnisname an Funktion bergeben.
    WriteDB_Folder = gdb_Folders!folder
    
End Function

Public Sub WriteDB_Address(ByVal vsName As String, ByVal vsAddress As String)

   'In dieser Prozedur wird ein neuer Datensatz mit den notwendigen Informationen der EMail-Adresse
   'erstellt.

    gdb_Mails.AddNew                        'Neuer Datensatz erstellen.
    gdb_Mails!Address = vsAddress           'EMail-Adresse hinzufgen.
    gdb_Mails!Name = vsName                 'Name des Senders/Empfngers hinzufgen.
    gdb_Mails!EntryDate = Now               'Erstellungsdatum hinzufgen.
    gdb_Mails!folder = gdb_Folders!folder   'Referenz auf Verzeichnisname hinzufgen.
    gdb_Mails.Update                        'Datensatz speichern.

End Sub

Private Sub WriteDB_LastUsed()

   'In dieser Prozedur wird das Feld "LastUsed" in beiden Tabellen aktualisiert.

    gdb_Mails!LastUsed = Now    'Datum der letzten Verwendung aktualisieren.
    gdb_Mails.Update
    
    gdb_Folders!LastUsed = Now  'Datum der letzten Verwendung aktualisieren.
    gdb_Folders.Update

End Sub

Private Function Get_ArchivFolder(ByVal vdtMailDate As Date) As MAPIFolder
    
   'In dieser Funktion wird geprft, ob bereits ein Archiv-Verzeichnis mit entsprechender Archivie-
   'rungs-Zeitspanne vorhanden ist. Falls noch keines besteht, muss der User per Dialog ein neues Ar-
   'chiv-Verzeichnis erstellen.
    
   'Konstanten fr die Abfrage, ob ein Verzeichnis erstellt werden soll.
    Const msgText   As String = "Kein Archiv mit diesem Zeitraum gefunden! Erstellen?"
    Const msgTitel  As String = "Archiv Folder nicht gefunden!"
    
    Dim i           As Long
    
   'Zeitangabe aus EMail-Datum entfernen.
    vdtMailDate = CDate(Format(vdtMailDate, "dd.mm.yyyy"))
    
   'Schleife fr alle bestehenden Archiv-Verzeichnisse initialisieren.
    For i = 1 To UBound(ga_Archives)
    
       'Prfen ob EMail-Datum sich innerhalb einer bestehenden Zeitspanne befindet.
        If vdtMailDate >= ga_Archives(i).dtFrom And vdtMailDate <= ga_Archives(i).dtTo Then
           
           'Falls das Datum innerhalb der Zeitspanne liegt, wird das Archiv an die Funktion bergeben.
            Set Get_ArchivFolder = Application.Session.GetFolderFromID(ga_Archives(i).sEntryID)
            
           'Funktion vorzeitig beenden.
            Exit Function
            
        End If
    Next i

   'Falls das Datum in keinem der bestehenden Archivierungs-Zeitspannen liegt, muss der User per Dialog
   'ein neues Archiv erstellen.

   'Dialog fr die Erstellung eines Archiv-Verzeichnisses anzeigen.
    frm_CreateFolder.Show
    
   'Prfen ob der User den Archivierungs-Prozess beenden mchte.
    If gl_Cancel = Abort.Interrupted Then Exit Function
    
   'Erstelltes Archiv-Verzeichnis an Funktion bergeben.
    Set Get_ArchivFolder = Application.Session.GetFolderFromID(ga_Archives(UBound(ga_Archives)).sEntryID)
    
End Function

Private Function Get_SubFolder(ByRef rArchiv As MAPIFolder, ByVal vsFolderName As String)

   'Mit dieser Funktion wird ein neues Unterverzeichnis erstellt. Dabei wird zuerst geprft, ob bereits
   'ein Verzeichnis mit diesem Namen existiert. Im neu erstellten Verzeichnis, wird gemss Parameter
   'das entsprechende View Objekt des gewhlten DefaultFolders angewendet.

    Dim objView      As View
    Dim objSubFolder As MAPIFolder

   'Prfen ob Unterverzeichnis bereits existiert.
    On Error Resume Next
    Set objSubFolder = rArchiv.Folders(vsFolderName)
    On Error GoTo 0
    
   'Falls das Verzeichnis noch nicht existiert, wird ein neues erstellt.
    If objSubFolder Is Nothing Then
    
       'Neues Verzeichnis im Archiv erstellen.
        Set objSubFolder = rArchiv.Folders.Add(vsFolderName, olFolderInbox)
         
       'In der Description Eigenschaft wird der Name ebenfalls hinterlegt.
        objSubFolder.Description = vsFolderName
        
       'Vordefiniertes benutzerspezifisches View Objekt auf neues Archiv-Verzeichnis anwenden.
        With objSubFolder.Views(gs_VIEW)
            .Apply
            .LockUserChanges = False
        End With
        
    End If
    
   'Unterverzeichnis an Funktion bergeben.
    Set Get_SubFolder = objSubFolder

End Function

Private Sub Enable_Controls(ByVal vbEnable As Boolean)
    
   'In dieser Prozedur werden die Steuerelemente fr die Archivierung der EMail-Objekte wahlweise ak-
   'tiviert oder deaktiviert (abhngig vom Parameter).
   
    With frm_Archiving
        
        .frameSuggestion.Enabled = vbEnable
        .txtSuggestion.Enabled = vbEnable
        .frameArchive.Enabled = vbEnable
        .txtFolder.Enabled = vbEnable
        .cmdArchive.Enabled = vbEnable
        .cmdIgnore.Enabled = vbEnable
        .cmdShow.Enabled = vbEnable
        .cmdAcceptAll.Enabled = vbEnable
        .cmdIgnoreAll.Enabled = vbEnable

       'Falls die Steuerelemente aktiviert werden, wird der Auswahl-Combobox den Fokus bergeben und
       'der Inhalt wird markiert.
       
        If vbEnable Then
            With .cboFolder
                .SetFocus
                .SelStart = 0
                .SelLength = Len(.Text)
            End With
        End If
        
    End With

End Sub
