Attribute VB_Name = "mod_Suggestion"
    Option Explicit

Public Function Get_Suggestion(ByVal vsName As String, ByVal vsAddress As String) As Variant

   'In dieser Prozedur wird zu aller erst ein Verzeichnis-Vorschlag ermittelt. Nachdem dieser entweder
   'aus dem Namen oder der EMail-Adresse des Empfngers/Senders ermittelt wurde, werden alle mglichen
   'Kombinationen (Permutation) ermittelt und als Vorschlag in die Combobox bertragen. Zudem wird in
   'der Datenbank nach hnlichen Namen gesucht und diese ebenfalls als Vorschlge in der Listbox aus-
   'gewiesen.
    
    Dim strNames()      As String
    Dim strSuggestion() As String

   'Verzeichnis-Vorschlag in einzelne Elemente aufteilen.
    strNames = Split(Get_NameElements(vsName, vsAddress))
    
   'Falls der Vorschlag aus mehr als 4 Elementen besteht, wird der Vorschlag gekrzt. Die
   'Permutation mit mehr als 4 Elementen wrde zu viele Mglichkeiten zurckgeben.
   
    If UBound(strNames) > 3 Then
       'Array auf 4 Positionen krzen.
        ReDim Preserve strNames(0 To 3) As String
    End If
    
   'Array fr die Ermittlung der Permutation der Namens-Elemente initialisieren.
    ReDim myOrders(0 To UBound(strNames)) As String
    ReDim strSuggestion(0) As String
   
   'Alle mglichen Kombinationen des Namens in ein Array schreiben.
    Call Get_Possibilities(UBound(strNames), strNames, myOrders, strSuggestion)
    
   'berflssige Position im Array wieder lschen.
    ReDim Preserve strSuggestion(UBound(strSuggestion) - 1) As String
    
    If Not gb_AcceptAll Then
       'Vorschlge in Combobox und Listbox anzeigen.
        Call Show_Suggestions(strNames, strSuggestion)
    End If
    
   'Array aller Mglichkeiten an Funktion bergeben.
    Get_Suggestion = strSuggestion

End Function

Private Sub Show_Suggestions(ByRef rsNames() As String, ByRef rsSugg() As String)
    
   'In dieser Prozedur wird aufgrund des ermittelten Verzeichnis-Vorschlags, die Tabelle "Mails" im
   'Feld "Name" und die Tabelle "Folder" im Feld "Folder" nach bereinstimmungen gesucht. Falls ein
   'Element des Namens in einer der Tabellen gefunden wird, wird dieser Eintrag ebenfalls als Vorschlag
   'in der Listbox aufgefhrt.
    
    Dim i           As Long
    Dim lngLen      As Long
    Dim strCheck    As String
    Dim strFilter   As String
    
   'Mindestanzahl an Buchstaben pro Namens-Element definieren.
    lngLen = 3
    
   'Filter erstellen, damit hnliche oder bereinstimmende Verzeichnis-Namen ebenfalls als Vorschlag in
   'der Listbox angezeigt werden. Im ersten Durchlauf werden alle Namens-Elemente mit weniger als 4
   'Buchstaben bei der Filter-Erstellung ignoriert. Falls alle Elemente weniger als 4 Buchstaben auf-
   'weisen, wird der Durchgang mit weniger als 3 Buchstaben wiederholt usw.
    
    Do
        For i = 0 To UBound(rsNames)
           'Prfen ob das Namens-Element ber gengend Zeichen verfgt.
            If Len(rsNames(i)) > lngLen Then
               'Filter erstellen fr die Felder "Folder" und "Name".
                strFilter = strFilter & " OR Name Like '*" & rsNames(i) & "*'" & _
                                        " OR Folder Like '*" & rsNames(i) & "*'" & _
                                        " OR Address Like '*" & rsNames(i) & "*'"
            End If
        Next i
        
       'Schwelle der Mindestanzahl Zeichen herabsetzen.
        lngLen = lngLen - 1
        
    Loop Until strFilter <> "" Or lngLen = 0
    
   'Tabelle "Mails" filtern um mgliche bereinstimmende Verzeichnisse zu ermitteln.
    gdb_Mails.Filter = Mid(strFilter, 5)
    
   'Prfen ob in der Datenbank entsprechende Eintrge gefunden wurden.
    Do Until gdb_Mails.EOF
       
       'Falls Records gefiltert wurden, alle in die Listbox bertragen, vorausgesetzt, dass nicht be-
       'reits ein gleichnamiger Eintrag in der Listbox vorhanden ist.
       
       'Den dazugehrigen Verzeichnis-Namen in der Tabelle "Folder" suchen.
        gdb_Folders.Find "Folder = '" & gdb_Mails!folder & "'", , , 1
       
       'Prfen ob Verzeichnisname in der Tabelle "Folders" gefunden wurde.
        If Not gdb_Folders.EOF Then
            
           'Prfen ob Verzeichnisname der Listbox bereits hinzugefgt wurde.
            If InStr(1, strCheck, gdb_Folders!folder, vbBinaryCompare) = 0 Then
             
               'Verzeichnisname im Check-String aufnehmen.
                strCheck = strCheck & vbTab & gdb_Folders!folder
            
               'Datensatz in der Listbox hinzufgen.
                With frm_Archiving.listSuggestion
                    .AddItem
                    .List(.ListCount - 1, 0) = gdb_Folders!folder
                    .List(.ListCount - 1, 1) = gdb_Mails!Address
                    .List(.ListCount - 1, 2) = Format(gdb_Folders!EntryDate, "dd.mm.yyyy - hh:mm:ss")
                    .List(.ListCount - 1, 3) = Format(gdb_Folders!LastUsed, "dd.mm.yyyy - hh:mm:ss")
                End With
                 
            End If
        End If
        
       'Zum nchsten Datensatz im Filter wechseln.
        gdb_Mails.MoveNext

    Loop
    
   'Filter der Datenbank zurcksetzen.
    gdb_Mails.Filter = ""
    
   'Verzeichnisvorschlge in Combobox schreiben und 1. Eintrag selektieren.
    With frm_Archiving.cboFolder
        .List = rsSugg
        .ListIndex = 0
    End With
    
End Sub

Public Function Get_NameElements(ByVal vsName As String, ByVal vsAddress As String) As String
    
   'In dieser Prozedur wird ermittelt, ob der Name des Senders/Empfngers fr die Aufbereitung des
   'Verzeichnis-Vorschlages verwendet werden soll oder die EMail-Adresse. Je nachdem von wem die EMail
   'gesendet wurde, stehen unterschiedliche Werte in den Eigenschaften. Danach werden ungewollte Zeichen
   'Zeichenfolgen gelscht resp. ersetzt. Zudem wird sichergestellt, dass der Vorschlag in normaler
   'Gross- und Kleinschreibung erstellt wird.
    
    Dim i       As Long
    Dim strName As String

   'Falls hinter dem Namen des Empfngers/Senders die EMail-Adresse in Klammern angegeben ist, wird alles
   'was rechts neben der ersten Klammer steht, abgeschnitten.
    If InStr(1, vsName, "(", vbBinaryCompare) <> 0 Then
        vsName = Trim(Left(vsName, InStr(1, vsName, "(", vbBinaryCompare) - 1))
    End If
   
   'Prfen ob der Name und auch die Adresse aus einer EMail-Adresse besteht. In diesem Fall wird fr die
   'Ermittlung des Verzeichnis-Vorschlags die EMail-Adresse ohne Provider verwendet. Andernfalls wird der
   'Name des Empfngers/Senders verwendet. Da die Namen zum Teil in Grossbuchstaben geschrieben sind, wird
   'ebenfalls in einem 1. Schritt alles in Kleinbuchstaben umgewandelt.
   
    If vsName Like "*?@?*.??*" And vsAddress Like "*?@?*.??*" Then
       'Provider aus der EMail-Adresse lschen und in den Rest in Kleinbuchstaben umwandeln.
        strName = Mid(LCase(vsAddress), 1, InStr(1, vsAddress, "@") - 1)
    Else
       'Name des Empfngers/Senders bernehmen und in Kleinbuchstaben umwandeln.
        strName = LCase(vsName)
    End If
        
   'Unerwnschte Zeichen aus dem vorlufigen Vorschlag entfernen oder durch Leerschlag ersetzen.
    strName = Replace(strName, "herr", "", , , vbBinaryCompare)     'Anrede entfernen
    strName = Replace(strName, "frau", "", , , vbBinaryCompare)     'Anrede entfernen
    strName = Replace(strName, ".", " ", , , vbBinaryCompare)       'Punkte ersetzen
    strName = Replace(strName, ",", " ", , , vbBinaryCompare)       'Kommas ersetzen
    strName = Trim(Replace(strName, "_", " ", , , vbBinaryCompare)) 'Unterstrich ersetzen
    
   'Doppelte Leerschlge in einfache ersetzen.
    Do Until InStr(1, strName, "  ", vbBinaryCompare) = 0
        strName = Trim(Replace(strName, "  ", " ", , , vbBinaryCompare))
    Loop
   
   'Bindestrich am Anfang und Ende des Namens entfernen.
    If Right(strName, 1) = "-" Then strName = RTrim(Mid(strName, 1, Len(strName) - 1))
    If Left(strName, 1) = "-" Then strName = LTrim(Mid(strName, 2))

   'Das erste Zeichen in ein Grossbuchstabe umwandeln.
    Mid(strName, 1, 1) = UCase(Mid(strName, 1, 1))
    
   'Alle Anfangsbuchstaben durch Grossbuchstaben ersetzen.
    For i = 2 To Len(strName)
       'Alle Buchstaben nach einem Leerschlag oder Bindestrich in Grossbuchstaben umwandeln.
        If InStr(1, "- ", Mid(strName, i, 1), vbBinaryCompare) <> 0 Then
            Mid(strName, i + 1, 1) = UCase(Mid(strName, i + 1, 1))
        End If
    Next i

   'Verzeichnis-Vorschlag an Funktion bergeben.
    Get_NameElements = strName

End Function

Private Sub Get_Possibilities(ByVal vlUBound As String, ByRef rsElements() As String, _
                              ByRef rsOrder() As String, ByRef rsSuggestions() As String)

   'Der Quellcode fr die Ermittlung der Permutation stammt von http://www.vbi.org

    Dim i            As Long
    Dim lngLen       As Long
    Dim lngPos       As Long
    Dim strElement   As String
   
    lngLen = UBound(rsElements) - LBound(rsElements) + 1
    lngPos = vlUBound - lngLen + 1
   
    If lngLen = 1 Then
        rsOrder(lngPos) = rsElements(LBound(rsElements))
        rsSuggestions(UBound(rsSuggestions)) = Join(rsOrder, " ")
        ReDim Preserve rsSuggestions(UBound(rsSuggestions) + 1) As String
    Else
        For i = LBound(rsElements) To UBound(rsElements)
            strElement = rsElements(i)
            rsOrder(lngPos) = strElement
            Get_Possibilities vlUBound, Remove_FromArray(rsElements, strElement), rsOrder, rsSuggestions
        Next i
    End If

End Sub

Private Function Remove_FromArray(ByRef rsElements() As String, ByVal vsElement As String) As String()

   'Der Quellcode fr die Ermittlung der Permutation stammt von http://www.vbi.org

    Dim NewArray() As String
    Dim i          As Long
    Dim newi       As Long
    
    ReDim NewArray(LBound(rsElements) To UBound(rsElements) - 1)
    
    For i = LBound(rsElements) To UBound(rsElements)
        If rsElements(i) <> vsElement Then
            NewArray(newi) = rsElements(i)
            newi = newi + 1
        End If
    Next
    
    Remove_FromArray = NewArray

End Function
